diff -urN versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/bematech/MP25.py trunk/stoqdrivers/printers/bematech/MP25.py
--- versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/bematech/MP25.py	2016-12-29 14:30:59.000000000 -0200
+++ trunk/stoqdrivers/printers/bematech/MP25.py	2017-01-23 16:54:44.669415181 -0200
@@ -390,37 +672,58 @@
 
     def _get_coupon_subtotal(self):
         subtotal = self._send_command(CMD_GET_COUPON_SUBTOTAL, response='7s')
+
         if subtotal:
             return Decimal(bcd2dec(subtotal)) / Decimal("1e2")
         # Busted subtotal
         return Decimal("0.0")
 
     def _get_last_item_id(self):
-        return self._read_register(self.registers.LAST_ITEM_ID)
+        try:
+            res = self._read_register(self.registers.LAST_ITEM_ID)
+        except Exception as e:
+            log.error(str(e))
+            res = 999
+
+        return res
 
     def _get_coupon_number(self):
         coupon_number = self._send_command(CMD_GET_COUPON_NUMBER, response='3s')
         return bcd2dec(coupon_number)
 
-    def get_status(self, val=None):
-        if val is None:
-            val = self._send_command(CMD_STATUS, raw=True)
+    def get_status(self, val=None, cmd_status=None):
+        log.debug("get_status(%r, %r)" % (val, cmd_status))
+
+        # if not val:
+        #     val = self._send_command(1, raw=True)
 
+        if cmd_status is None:
+            cmd_status = CMD_STATUS
+
+        if val is None:
+            val = self._send_command(cmd_status, raw=True)
+            print 'st', val
+            #val = self._send_command(1, raw=True)
         return MP25Status(val)
 
-    def _add_voucher(self, type, value):
+    def _add_voucher(self, type, value, text=''):
         assert len(type) == 2
-
         status = self.get_status()
         if status.open:
             self._send_command(CMD_COUPON_CANCEL)
+        ret = self._send_command(CMD_ADD_VOUCHER, type, "%014d%s" % (int(value * Decimal('1e2')), text), raw=True)
+        self.get_status(ret).check_error()
 
-        self._send_command(CMD_ADD_VOUCHER, type, "%014d" % int(value * Decimal('1e2')))
-
-    def _configure_payment_methods(self):
+    def _configure_payment_methods(self, descricao):
         # Do one at a time, if you need it.
         ret = self._send_command(CMD_PROGRAM_PAYMENT_METHOD,
-                                 '%-16s1' % 'Cartao Credito', raw=True)
+                                 '%-16s' % descricao[:80], response='3', raw=False)
+        try:
+            int(ret[1:3])
+            return ret[1:3]
+        except:
+            print 'Finalizadora cheia'
+            return False
         #ret = self._send_command(CMD_PROGRAM_PAYMENT_METHOD,
         #                         '%-16s1' % 'Cartao Debito', raw=True)
         #ret = self._send_command(CMD_PROGRAM_PAYMENT_METHOD,
@@ -432,7 +735,48 @@
 
     def summarize(self):
         """ Prints a summary of all sales of the day """
-        self._send_command(CMD_READ_X)
+        return self._send_command(CMD_READ_X, raw=True)
+
+    def get_totalizadores(self, total=False):
+        '''
+        Esta funcao busca cada totalizador da ecf e seus valores
+        '''
+        total_cancelations = self._read_register(self.registers.TOTAL_CANCELATIONS)
+        total_discount = self._read_register(self.registers.TOTAL_DISCOUNT)
+
+        length, names = self._send_command(CMD_READ_TAXCODES, response='b32s') # quantidade e nome dos totalizadores
+        status = self._read_register(self.registers.TOTALIZERS)
+        status = struct.unpack('>H', status)[0]
+        if total: # pega todos totalizadores (ver manual da bematec)
+            cmd_totalizadores = CMD_READ_TOTALIZERS
+            response = '436s'
+        else: # nao pega todos totalizadores
+            cmd_totalizadores = CMD_READ_TOTALIZERS_PARCIAL
+            response = '219s'
+
+        values = self._send_command(cmd_totalizadores, response=response)
+        taxes = []
+        for i in range(length):
+            if 1 << 15 - i & status != 0:
+                type = 'ISS'
+            else:
+                type = 'ICMS'
+
+            name = bcd2hex(names[i * 2:i * 2 + 2])
+            value = bcd2dec(values[i * 7:i * 7 + 7])
+            taxes.append(('%02d' % (i+1), value / Decimal(100), type))
+
+        taxes.append(('ACRESC', bcd2dec(values[182:182 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('ACRESC', bcd2dec(values[161:161 + 7]) / Decimal(100), 'ICMS'))
+        taxes.append(('CANC', bcd2dec(values[189:189 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('CANC', total_cancelations / Decimal(100), 'ICMS'))
+        taxes.append(('DESC', bcd2dec(values[175:175 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('DESC', total_discount / Decimal(100), 'ICMS'))
+        taxes.append(('I', bcd2dec(values[112:119]) / Decimal(100), 'ICMS'))
+        taxes.append(('N', bcd2dec(values[119:126]) / Decimal(100), 'ICMS'))
+        taxes.append(('F', bcd2dec(values[126:133]) / Decimal(100), 'ICMS'))
+        return taxes
+
 
     def close_till(self, previous_day=False):
         """ Close the till for the day, no other actions can be done after this
@@ -443,21 +787,26 @@
         # não é fechado no mesmo dia
         self._send_command(CMD_REDUCE_Z)
 
-    def till_add_cash(self, value):
-        self._add_voucher(CASH_IN_TYPE, value)
+    def till_add_cash(self, value, totalizador=0, meio=0):
+        self._add_voucher(CASH_IN_TYPE, value, text='')
 
-    def till_remove_cash(self, value):
-        self._add_voucher(CASH_OUT_TYPE,value)
+    def till_remove_cash(self, value, cod=None, text=''):
+        self._add_voucher(CASH_OUT_TYPE, value, text)
 
-    def till_read_memory(self, start, end):
+    def till_read_memory(self, start, end, full=False):
+        i = 'i' if not full else 'I'
         self._send_command(CMD_READ_MEMORY,
-                           '%s%sI' % (start.strftime('%d%m%y'),
-                                      end.strftime('%d%m%y')))
+                           '%s%s%s' % (start.strftime('%d%m%y'),
+                                      end.strftime('%d%m%y'),
+                                      i))
 
-    def _till_read_memory_to_serial(self, start, end):
-        ret = self._send_command(CMD_READ_MEMORY,
-                           '%s%sR' % (start.strftime('%d%m%y'),
-                                      end.strftime('%d%m%y')))
+    def till_read_memory_to_serial(self, start, end, full=False):
+        r = 'r' if not full else 'R'
+        self._send_command(CMD_READ_MEMORY,
+                           '%s%s%s' % (start.strftime('%d%m%y'),
+                                       end.strftime('%d%m%y'),
+                                       r)
+                           )
 
         data = ''
         while True:
@@ -469,9 +818,25 @@
 
         return data
 
-    def till_read_memory_by_reductions(self, start, end):
+    def till_read_memory_by_reductions_to_serial(self, start, end, full=False):
+        r = 'r' if not full else 'R'
+        ret = self._send_command(CMD_READ_MEMORY,
+                                 '%06d%06d%s' % (start, end, r))
+        data = ''
+        while True:
+            c = self.read(1)
+            if ord(c) == 0x03:
+                break
+
+            data += unicode(c, self.coupon_printer_charset)
+
+        return data
+
+
+    def till_read_memory_by_reductions(self, start, end, full=False):
+        i = 'i' if not full else 'I'
         self._send_command(CMD_READ_MEMORY,
-                           '%06d%06dI' % (start, end))
+                           '%06d%06d%s' % (start, end, i))
 
     def coupon_identify_customer(self, customer, address, document):
         self._customer_name = customer
@@ -483,16 +848,22 @@
 
     def coupon_open(self):
         """ This needs to be called before anything else """
-        self._send_command(CMD_COUPON_OPEN,
-                            "%-29s%-30s%-80s" % (self._customer_document,
-                                                 self._customer_name,
-                                                 self._customer_address))
-
+        if self._customer_name:
+            ret = self._send_command(CMD_COUPON_OPEN,
+                                "%-29s%-30s%-80s" % (self._customer_document,
+                                                     self._customer_name,
+                                                     self._customer_address), raw=True)
+        else:
+            ret = self._send_command(CMD_COUPON_OPEN, raw=True)
+        self.get_status(ret).check_error()
+        return ret
     def coupon_cancel(self):
         """ Can only be called when a coupon is opened. It needs to be possible
         to open new coupons after this is called.
         """
-        self._send_command(CMD_COUPON_CANCEL)
+        retcmd = self._send_command(CMD_COUPON_CANCEL, raw=True)
+        self.get_status(retcmd).check_error()
+
 
     def cancel_last_coupon(self):
         """Cancel the last non fiscal coupon or the last sale."""
@@ -504,10 +875,10 @@
         new coupons after this is called.
         """
         # FIXME This will break the drivers recorded tests. Record new ones.
-        #self._send_command(CMD_COUPON_CLOSE, message)
-        self._send_command(CMD_COUPON_CLOSE)
+        message = re.sub(r'NOTA LEGAL:', chr(27) + chr(69) + r'NOTA LEGAL:' + chr(27) + chr(70) , message)
+        self._send_command(CMD_COUPON_CLOSE, message)
         self._reset()
-        return self._get_coupon_number()
+        return True
 
     def coupon_add_item(self, code, description, price, taxcode,
                         quantity=Decimal("1.0"), unit=UnitType.EMPTY,
@@ -518,12 +889,14 @@
         by stoq. In this case, the payments added will be higher than the ECF
         expects, and a cents change will be printed.
         """
+        if taxcode in ['F', 'I', 'N']:
+            taxcode += taxcode
         if unit == UnitType.CUSTOM:
             unit = unit_desc
         else:
             unit = self._consts.get_value(unit)
 
-        data = ("%02s"     # taxcode
+        data = ("%s"     # taxcode
                 "%09d"     # value
                 "%07d"     # quantity
                 "%010d"    # discount
@@ -532,38 +905,61 @@
                 "%2s"      # unit
                 "%-48s\0"  # code
                 "%-200s\0" # description
-                % (taxcode,
+                % (taxcode.rjust(2, '0'),
                    price * Decimal("1e3"),
                    quantity * Decimal("1e3"),
                    discount * Decimal("1e2"),
                    markup * Decimal("1e2"),
                    0, unit, code, description))
-        self._send_command(CMD_ADD_ITEM, data)
+        di = datetime.datetime.now()
+
+        retval = self._send_command(CMD_ADD_ITEM, data, raw=True)
+
+        self.get_status(retval).check_error()
         return self._get_last_item_id()
 
+    def desc_acres_item(self, desc_acres, item, valor):
+        '''
+        Efetua desconto acrescimo no item
+        :param desc_acres: 'A' para acrescimo, 'D' para desconto, 1 byte
+        :param item: numero de sequencia do item no cupom, 3 bytes
+        :param valor: valor do desconto/acrescimo,  8 bytes
+        :return:
+        '''
+
+        parametros = desc_acres + \
+                     "%03d" % item + \
+                     "%08d" % (Decimal(valor).quantize(TWOPLACES) * Decimal("1e2"))
+        return self._send_command(CMD_DISCOUNT_SURCHARGE_AFTER, parametros)
+
+    def cancel_last_item(self):
+        return self._send_command(CMD_CANCEL_LAS_ITEM)
+
     def coupon_cancel_item(self, item_id=None):
         """ Cancel an item added to coupon; if no item id is specified,
         cancel the last item added. """
         last_item = self._get_last_item_id()
         if item_id is None:
-            item_id = last_item
-        elif item_id not in xrange(1, last_item+2):
+            return self.cancel_last_item()
+
+        elif item_id not in xrange(1, last_item + 2):
             raise CancelItemError("There is no such item with ID %r"
                                   % item_id)
-        self._send_command(CMD_CANCEL_ITEM, "%04d" % (item_id,))
+        retcmd = self._send_command(CMD_CANCEL_ITEM, "%04d" % (item_id,), raw=True)
+        self.get_status(retcmd).check_error()
 
     def coupon_add_payment(self, payment_method, value, description=u""):
-        self._send_command(CMD_ADD_PAYMENT,
-                           "%s%014d%s" % (payment_method[:2],
-                                          int(value * Decimal('1e2')),
-                                          description[:80]))
+        #payment_method = '01'
+        retval = self._send_command(CMD_ADD_PAYMENT, "%s%014d%s" % (
+        payment_method, int(value * Decimal('1e2')), description[:80]), raw=True)
+        if retval[3] != 23:
+            self.get_status(retval).check_error()
         self.remainder_value -= value
         if self.remainder_value < 0.0:
             self.remainder_value = Decimal("0.0")
         return self.remainder_value
 
-    def coupon_totalize(self, discount=currency(0), markup=currency(0),
-                        taxcode=TaxType.NONE):
+    def coupon_totalize(self, discount=currency(0), markup=currency(0), taxcode=TaxType.NONE):
 
         if discount:
             type = 'd'
@@ -576,9 +972,10 @@
             # be specified.
             type = 'a'
             value = 0
-
-        self._send_command(CMD_COUPON_TOTALIZE, '%s%014d' % (
-            type, int(value * Decimal('1e2'))))
+        vlr = '%s%014d' % (type, int(value * Decimal('1e2')))
+        retval = self._send_command(CMD_COUPON_TOTALIZE, vlr, raw=True)
+        if retval[2] == 1:
+            self.get_status(retval).check_error()
 
         totalized_value = self._get_coupon_subtotal()
         self.remainder_value = totalized_value
@@ -594,33 +991,84 @@
             if value == method_id:
                 return name
 
-    def payment_receipt_open(self, identifier, coo, method_id, value):
-        method = self._get_payment_description(method_id)
+    def gerencial_report_open(self, id=None):
+        if id:
+            st = self._send_command(CMD_GERENCIAL_REPORT_OPEN, '%02d' % id, raw=True)
+        else:
+            st = self._send_command(CMD_GERENCIAL_REPORT_PRINT, raw=True)
+        self.get_status(st).check_error()
+
+    def gerencial_report_print(self, text):
+        imprime_linha = ''
+        for line in text.split('\n'):
+            if len(imprime_linha + '\n' + line) > 620: # limite de caracteres do comando CMD_GERENCIAL_REPORT_PRINT
+                self._send_command(CMD_GERENCIAL_REPORT_PRINT, imprime_linha)
+                imprime_linha = ''
+
+            imprime_linha += '\n' + line
+
+        self._send_command(CMD_GERENCIAL_REPORT_PRINT, imprime_linha) # imprime a o restante do texto
+
+    def gerencial_report_close(self):
+        self._send_command(CMD_GERENCIAL_REPORT_CLOSE)
+
+    def payment_receipt_open(self, identifier, coo, method, value):
+        method = self._get_payment_description(method)
         if not method:
             raise DriverError('Looks like this payment method '
                               'is not configured in the printer')
 
-        value = int(value*100)
-        self._send_command(CMD_PAYMENT_RECEIPT_OPEN,
-                           '%-16s%014d%06d' % (method, value, coo))
+        value = int(value * 100)
+        res = self._send_command(CMD_PAYMENT_RECEIPT_OPEN,
+                           '%-16s%014d%06d' % (method, value, coo), raw=True)
+        # verifica o status do retorno do comando
+        MP25Status(res).check_error()
+        return True
+
+    def get_corta_papel(self): # a MP 2100 nao possuem comando para cortar papel
+        try: # 62, 75 => corta papel, 7 = linhas a avancar, 1=corte parcial
+            res = self._send_command(62, 75, 7, 1, raw=True)
+            MP25Status(res).check_error()
+        except Exception as e:
+            log.error("Erro ao cortar papel: %s" % str(e))
+            return False
+
+        return True
 
     def payment_receipt_print(self, text):
+        imprime_linha = ''
         for line in text.split('\n'):
-            self._send_command(CMD_PAYMENT_RECEIPT_PRINT, line + '\n')
+            if len(imprime_linha + '\n' + line) > 620: # limite de caracteres do comando CMD_PAYMENT_RECEIPT_PRINT
+                self._send_command(CMD_PAYMENT_RECEIPT_PRINT, imprime_linha)
+                imprime_linha = ''
+
+            if line == 'corta_papel':
+                if imprime_linha:
+                    self._send_command(CMD_PAYMENT_RECEIPT_PRINT, imprime_linha)
+                    imprime_linha = ''
+
+                if not self.get_corta_papel():
+                    imprime_linha = '\n------------------------------------------------\n\n'
+
+                continue
+
+            imprime_linha += '\n' + line
+
+        self._send_command(CMD_PAYMENT_RECEIPT_PRINT, imprime_linha) # imprime a o restante do texto
 
     def payment_receipt_close(self):
-        ret = self._send_command(CMD_PAYMENT_RECEIPT_CLOSE)
+        self._send_command(CMD_PAYMENT_RECEIPT_CLOSE)
 
     def payment_receipt_print_duplicate(self):
         self._send_command(CMD_PAYMENT_RECEIPT_PRINT_DUPLICATE)
 
     def get_capabilities(self):
         return dict(
-            item_code=Capability(max_len=13),
+            item_code=Capability(max_len=14),
             item_id=Capability(digits=4),
             items_quantity=Capability(min_size=1, digits=4, decimals=3),
             item_price=Capability(digits=6, decimals=2),
-            item_description=Capability(max_len=29),
+            item_description=Capability(max_len=200),
             payment_value=Capability(digits=12, decimals=2),
             promotional_message=Capability(max_len=320),
             payment_description=Capability(max_len=48),
@@ -652,9 +1100,28 @@
     def get_coo(self):
         return self._read_register(self.registers.COO)
 
+    def get_coo_inicial_final(self):
+        return self._read_register(self.registers.COO_INICIAL_FINAL)
+
+    def get_read_ie(self):
+        return self._read_register(self.registers.READ_IE)
+
+    def get_num_loja(self):
+        return self._read_register(self.registers.READ_LOJA)
+
+    def get_num_ecf(self):
+        return self._read_register(self.registers.NUMBER_TILL)
+
     def get_gnf(self):
         return self._read_register(self.registers.GNF)
 
+    def get_cfc(self):
+        return self._read_register(self.registers.CFC)
+    def get_grg(self):
+        return self._read_register(self.registers.GRG)
+    def get_cdc(self):
+        return self._read_register(self.registers.CDC)
+
     def get_crz(self):
         return self._read_register(self.registers.NUMBER_REDUCTIONS_Z)
 
@@ -667,22 +1134,22 @@
         service = False
         constants = []
         for i in range(16):
-            value = bcd2dec(data[i*2:i*2+2])
+            value = bcd2dec(data[i * 2:i * 2 + 2])
             if not value:
                 continue
 
-            if 1 << 15-i & status == 0:
+            if 1 << 15 - i & status == 0:
                 tax = TaxType.CUSTOM
             else:
                 tax = TaxType.SERVICE
             constants.append((tax,
-                              '%02d' % (i+1,),
+                              '%02d' % (i + 1,),
                               Decimal(value) / 100))
 
         constants.extend([
             (TaxType.SUBSTITUTION, 'FF', None),
-            (TaxType.EXEMPTION,    'II', None),
-            (TaxType.NONE,         'NN', None),
+            (TaxType.EXEMPTION, 'II', None),
+            (TaxType.NONE, 'NN', None),
             ])
 
         return constants
@@ -691,11 +1158,37 @@
         status = self._read_register(self.registers.PAYMENT_METHODS)[1]
         methods = []
         for i in range(20):
-            method = status[i*16:i*16+16]
+            method = status[i * 16:i * 16 + 16]
             if method != '\x00' * 16:
-                methods.append(('%02d' % (i+1), method.strip()))
+                methods.append(('%02d' % (i + 1), method.strip()))
         return methods
 
+    def get_grande_total(self):
+        grande_total = self._read_register(self.registers.TOTAL)
+        grande_total = grande_total / Decimal(100)
+        return grande_total
+
+    def get_date_last_mov_rz(self):
+        '''
+        :return: Retorna a data do movimento da ultima reducao Z emitida
+        '''
+        str_date_mov_last_rz = str(self._read_register(self.registers.DATE_MOV_LAST_RZ))
+        try:
+            if len(str_date_mov_last_rz) == 5:
+                str_date_mov_last_rz = '0' + str_date_mov_last_rz
+
+            date_last_mov_rz = datetime.datetime(year=2000 + int(str_date_mov_last_rz[4:6]),
+                                                 month=int(str_date_mov_last_rz[2:4]),
+                                                 day=int(str_date_mov_last_rz[:2])).date()
+        except Exception as e:
+            # quando emite um Z que nao eh pendente em um dia que nao teve movimentacao, a data do movimento
+            # do dele nao existe.
+            log.error('get_date_last_mov_rz: %s' % str(e))
+            date_last_mov_rz = 0
+
+        return date_last_mov_rz
+
+
     def get_sintegra(self):
         opening_date = self._read_register(self.registers.EMISSION_DATE)
         cro = self._read_register(self.registers.CRO)
@@ -703,54 +1196,148 @@
         # -1
         crz = self._read_register(self.registers.NUMBER_REDUCTIONS_Z)
         coo = self._get_coupon_number()
+        ccf = self.get_ccf()
+        gnf = self.get_gnf()
+        grg = self.get_grg()
+        cdc = self.get_cdc()
+        serial = self.get_serial()
         total_cancelations = self._read_register(self.registers.TOTAL_CANCELATIONS)
         total_discount = self._read_register(self.registers.TOTAL_DISCOUNT)
 
-        # Avbr function TACBrECFBematech.GetVendaBruta
-        registers = self._send_command(62 , 55, response='308s')
-        coupon_end = int(bcd2hex(registers)[568:568+6])
+        registers = self._send_command(62, 55, response='308s')
+        if self.get_status().st3 == 143:
+            raise self.get_status().st3_codes[143]
+
+        #  cupom inicial
+        try:
+            coupon_start = int(bcd2hex(registers)[568:568 + 6]) + 1
+        except:
+            coupon_start = bcd2hex(registers)[568:568 + 6]
+
+        # cupom final
+        coupon_end = coo
 
         grande_total = self._read_register(self.registers.TOTAL)
-        grande_total = grande_total/Decimal(100)
-        total_bruto = bcd2dec(registers[1:10])/Decimal(100)
+        grande_total = grande_total / Decimal(100)
+
+        # este tratamento eh devido ao erro que da ao tentar ler o GT do ultimo Z, a string dos
+        # registradores retornada de "self._send_command(62, 55, response='308s')" vem toda
+        # desconfigurada, neste percebi que pode ser quando a ECF eh nova e nao houve Z ainda
+        try:
+            total_bruto = bcd2dec(registers[1:10]) / Decimal(100)
+        except:
+            try:
+                registers = self._send_command(62, 55, response='308s')
+                total_bruto = bcd2dec(registers[1:10]) / Decimal(100)
+            except Exception as e:
+                log.error('GT ultimo Z: %s', str(e))
+                total_bruto = Decimal(0)
 
         length, names = self._send_command(CMD_READ_TAXCODES, response='b32s')
         status = self._read_register(self.registers.TOTALIZERS)
         status = struct.unpack('>H', status)[0]
-        values = self._send_command(CMD_READ_TOTALIZERS, response='219s')
 
+        values = self._send_command(CMD_READ_TOTALIZERS, response='436s')
+
+        date = '%012d' % opening_date
         taxes = []
         for i in range(length):
-            if 1 << 15-i & status != 0:
+
+            if 1 << 15 - i & status != 0:
                 type = 'ISS'
             else:
                 type = 'ICMS'
 
-            name = bcd2hex(names[i*2:i*2+2])
-            value = bcd2dec(values[i*7:i*7+7])
-            taxes.append((name, value/Decimal(100), type))
-
-        taxes.append(('CANC', total_cancelations/Decimal(100), 'ICMS'))
-        taxes.append(('DESC', total_discount/Decimal(100), 'ICMS'))
-        taxes.append(('I', bcd2dec(values[112:119])/Decimal(100), 'ICMS'))
-        taxes.append(('N', bcd2dec(values[119:126])/Decimal(100), 'ICMS'))
-        taxes.append(('F', bcd2dec(values[126:133])/Decimal(100), 'ICMS'))
-        date = bcd2hex(opening_date[:6])
+            name = bcd2hex(names[i * 2:i * 2 + 2])
+            value = bcd2dec(values[i * 7:i * 7 + 7])
+            taxes.append((name, value / Decimal(100), type))
+
+        taxes.append(('ACRESC', bcd2dec(values[182:182 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('ACRESC', bcd2dec(values[161:161 + 7]) / Decimal(100), 'ICMS'))
+        taxes.append(('CANC', bcd2dec(values[189:189 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('CANC', total_cancelations / Decimal(100), 'ICMS'))
+        taxes.append(('DESC', bcd2dec(values[175:175 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('DESC', total_discount / Decimal(100), 'ICMS'))
+        taxes.append(('I', bcd2dec(values[112:119]) / Decimal(100), 'ICMS'))
+        taxes.append(('N', bcd2dec(values[119:126]) / Decimal(100), 'ICMS'))
+        taxes.append(('F', bcd2dec(values[126:133]) / Decimal(100), 'ICMS'))
+
+        serial_id = '%03d' % self._read_register(self.registers.NUMBER_TILL)
+
+        str_date_last_rz = str(self._read_register(self.registers.DATE_LAST_RZ))
+        try:
+            if len(str_date_last_rz) == 11:
+                str_date_last_rz = '0' + str_date_last_rz
+
+            date_last_rz = datetime.date(year=2000 + int(str_date_last_rz[4:6]),
+                                         month=int(str_date_last_rz[2:4]),
+                                         day=int(str_date_last_rz[:2]))
+        except Exception as e:
+            date_last_rz = {0: str_date_last_rz, 1: str(e)}
+
+        date_last_mov_rz = self.get_date_last_mov_rz()
+        if not date_last_mov_rz:
+            date_last_mov_rz = date_last_rz
+
 
         return Settable(
-             opening_date=datetime.date(year=2000+int(date[4:6]),
-                                        month=int(date[2:4]),
-                                        day=int(date[:2])),
-             serial=self.get_serial(),
-             serial_id='%03d' % self._read_register(self.registers.NUMBER_TILL),
-             coupon_start=0,
-             coupon_end=coupon_end,
-             cro=cro,
-             crz=crz,
-             coo=coo,
-             period_total=grande_total - total_bruto,
-             total=grande_total,
-             taxes=taxes)
+            date_last_rz=date_last_rz,
+            date_last_mov_rz=date_last_mov_rz,
+            opening_date=date_last_rz,
+            serial=serial,
+            serial_id=serial_id,
+            coupon_start=coupon_start,
+            coupon_end=coupon_end,
+            cro=cro,
+            crz=crz,
+            coo=coo,
+            ccf=ccf,
+            gnf=gnf,
+            grg=grg,
+            cdc=cdc,
+            period_total=grande_total - total_bruto,
+            total=grande_total,
+            taxes=taxes
+        )
+
+    def get_tax(self):
+        total_cancelations = self._read_register(self.registers.TOTAL_CANCELATIONS)
+        total_discount = self._read_register(self.registers.TOTAL_DISCOUNT)
+        # Avbr function TACBrECFBematech.GetVendaBruta
+
+        length, names = self._send_command(CMD_READ_TAXCODES, response='b32s')
+        status = self._read_register(self.registers.TOTALIZERS)
+        status = struct.unpack('>H', status)[0]
+
+        values = self._send_command(CMD_READ_TOTALIZERS, response='436s')
+
+        #        values2 = self._send_command(27, response='218s')
+        #        return (bcd2hex(values), bcd2hex(values2))
+
+        taxes = []
+        for i in range(length):
+
+            if 1 << 15 - i & status != 0:
+                type = 'ISS'
+            else:
+                type = 'ICMS'
+
+            name = bcd2hex(names[i * 2:i * 2 + 2])
+            value = bcd2dec(values[i * 7:i * 7 + 7])
+            taxes.append((name, value / Decimal(100), type))
+
+        taxes.append(('ACRESC', bcd2dec(values[182:182 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('ACRESC', bcd2dec(values[161:161 + 7]) / Decimal(100), 'ICMS'))
+        taxes.append(('CANC', bcd2dec(values[189:189 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('CANC', total_cancelations / Decimal(100), 'ICMS'))
+        taxes.append(('DESC', bcd2dec(values[175:175 + 7]) / Decimal(100), 'ISS'))
+        taxes.append(('DESC', total_discount / Decimal(100), 'ICMS'))
+        taxes.append(('I', bcd2dec(values[112:119]) / Decimal(100), 'ICMS'))
+        taxes.append(('N', bcd2dec(values[119:126]) / Decimal(100), 'ICMS'))
+        taxes.append(('F', bcd2dec(values[126:133]) / Decimal(100), 'ICMS'))
+
+        return taxes
+
 
     def get_firmware_version(self):
         """Return the firmware version"""
@@ -759,3 +1346,68 @@
         ret = '%0*d' % (6, ret)
         firmware = "%s:%s:%s" % (ret[0:2], ret[2:4], ret[4:6])
         return firmware
+    ##
+    # By Christian Douglas
+    ##
+    def set_summertime(self, value=True):
+        ret_cmd = self._send_command(CMD_SUMMER_TIME, raw=True)
+        self._check_error(ret_cmd)
+        return True
+
+    def get_summertime(self):
+        ret_cmd = bcd2hex(self._read_register(self.registers.FISCAL_FLAGS))
+        return isbitset(str(ret_cmd), 2)
+
+
+    def open_cash_drawer(self, sec=0):
+        return self._send_command(CMD_OPEN_TILL)
+
+    def get_status_cash_drawer(self):
+        retval = self._send_command(23, response='1s', raw=True)
+        result = True if retval[1] == '\xff' else False
+        return result
+
+    def get_date_sb(self):
+        ret_cmd = self._read_register(self.registers.CLICHE)
+        print ret_cmd, binascii.b2a_hex(ret_cmd)
+
+    def get_data_mov(self):
+        log.debug("get_data_mov")
+        ret_cmd = self._read_register(self.registers.MOV_DATE)
+        if ret_cmd == 0:
+            ret_cmd = 10100
+        return datetime.datetime.strptime('%06d' % ret_cmd, "%d%m%y").date()
+
+    def get_ecf_date(self):
+        log.debug("get_ecf_date")
+        ret_cmd = self._read_register(self.registers.EMISSION_DATE)
+        if ret_cmd == 0:
+            ret_cmd = 10100000000
+        return datetime.datetime.strptime('%012d' % ret_cmd, "%d%m%y%H%M%S")
+
+    def get_last_reduce(self):
+        rethex = binascii.b2a_hex(self._send_command(88, response='621s'))
+        GT_INI_FIM = self._read_register(self.registers.GT) or ''
+        GT_INI = float(str(GT_INI_FIM)[:18] or 0)
+        GTANT = Decimal(str( GT_INI / 100.00))
+        retval = {'CRO': int(rethex[2:6]),
+                  'CRZ': int(rethex[6:10]),
+                  'COO': int(rethex[10:16]),
+                  'GNF': int(rethex[16:22]),
+                  'CCF': int(rethex[22:28]),
+                  'GRG': int(rethex[28:34]),
+                  'CFD': int(rethex[34:40]),
+                  'NFC': int(rethex[40:44]),
+                  'CFC': int(rethex[44:48]),
+                  'COM': rethex[48:168],
+                  'CER': rethex[166:288],
+                  'CDC': int(rethex[288:292]),
+                  'NCN': int(rethex[292:296]),
+                  'CCDC': int(rethex[296:300]),
+                  'GT': Decimal(rethex[300:318]) / Decimal(100),
+                  'VBD': Decimal(rethex[300:318]) / Decimal(100) - GTANT}
+        return retval
+
+    def get_pagamento_existe(self):
+        ret_cmd = bcd2hex(self._read_register(self.registers.FISCAL_FLAGS))
+        return isbitset(str(ret_cmd), 1)
